/* tslint:disable:no-use-before-declare */
"use strict";
/**
 * No Case Found error message
 */
exports.NoCaseFound = 'no-case-found';
/**
 * Match statement
 * {{
 * Match( obj,
 *  Case( c => c === 'something', c => `c.toto`), ...
 * );
 * }}
 * @param a object to test
 * @param cases sets of cases to check.
 * @returns {B}
 * @throws 'no-case-found error' in case of no items match with cases.
 */
function Match(a) {
    var cases = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        cases[_i - 1] = arguments[_i];
    }
    var item = cases.find(function (c) { return c.test(a); });
    if (!item) {
        throw new Error(exports.NoCaseFound);
    }
    return item.exec(a);
}
exports.Match = Match;
function Case(test, exec) {
    return { test: test, exec: exec };
}
exports.Case = Case;
