/* tslint:disable:no-use-before-declare */
"use strict";
var Try_1 = require('./Try');
var MatchCase_1 = require('./MatchCase');
function PartialFunction() {
    var cases = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        cases[_i - 0] = arguments[_i];
    }
    return generate(function (arg) { return MatchCase_1.Match.apply(void 0, [arg].concat(cases)); }, function (arg) { return !!cases.find(function (c) { return c.test(arg); }); });
}
exports.PartialFunction = PartialFunction;
function orElse(a, b) {
    return generate(function (arg) { return a.isDefinedAt(arg) ? a(arg) : b(arg); }, function (arg) { return a.isDefinedAt(arg) || b.isDefinedAt(arg); });
}
function andThen(a, b) {
    var resB;
    var f = function (arg) {
        if (!resB) {
            resB = a(arg);
        }
        return resB;
    };
    return generate(function (arg) { return b(f(arg)); }, function (arg) { return a.isDefinedAt(arg) && b.isDefinedAt(f(arg)); });
}
function generate(f, find) {
    var res = function (arg) { return f(arg); };
    res.isDefinedAt = function (arg) { return find(arg); };
    res.orElse = function (other) { return orElse(res, other); };
    res.andThen = function (other) { return andThen(res, other); };
    res.lift = function () { return function (arg) { return Try_1.Try(function () { return f(arg); }).toOptional(); }; };
    res.applyOrElse = function (arg, orElse) { return Try_1.Try(function () { return f(arg); }).getOrElse(function () { return orElse(arg); }); };
    return res;
}
